'' Find Hidden Bug in Timestamp.spin
'' This program has deslays in TimerMs for finding the memory collision
'' bug. 

CON
   
  _clkmode = xtal1 + pll16x               ' Crystal and PLL settings.
  _xinfreq = 5_000_000                    ' 5 MHz crystal x 16 = 80 MHz.

OBJ

  debug  : "PST Debug LITE"               ' Serial communication object

VAR

  long stack[40]                          ' Ample stack for prototyping
  long m, s, ms, t, dt                    ' Timekeeping variables

PUB Go | minutes, seconds, milliseconds                                  

  debug.Style(debug#COMMA_DELIMITED)      ' Configure debug display
  debug.Start(115200)                     ' Start debug cog

  cognew(TimerMs, @stack)                 ' Launch timekeeping cog

  m  := 10                                ' **Add
  s  := 59                                ' **Add
  ms := 999                               ' **Add

  repeat 8                                ' **Modify to 8 reps Main loop
    waitcnt(clkfreq/3+cnt)                ' **Add
    longmove(@minutes, @m, 3)             ' Copy timestamp vars
    'debug.break                           ' **Remove
    debug.Vars(@m, String("| minutes, seconds, milliseconds"))

PRI TimerMs

  t  := cnt                               ' Current clock counter
  dt := clkfreq'/1000                      ' **Modify Ticks in 1 ms

  repeat                                  ' Infinite loop
    waitcnt(t+=dt)                        ' Wait for the next ms
    ms++                                  ' Add 1 to millisecond count
    waitcnt(clkfreq/4+cnt)                ' **Add
    if ms == 1000                         ' If milliseconds = 1000
      ms := 0                             '  Set milliseconds to 0
      s++                                 '  Increment seconds
      waitcnt(clkfreq/4+cnt)              ' **Add
    if s == 60                            ' if seconds = 60
      s := 0                              '  Set seconds to 0
      m++                                 '  Increment minutes
      waitcnt(clkfreq/4+cnt)              ' **Add
    if m == 60                            ' If minutes = 60
      m := 0                              '  Set minutes to 0
      